<template>
        <div class="d-md-flex align-items-center flex-wrap justify-content-center p-4 contenedorPrincipal mt-3">
                <label for="periodoActivo" class="form-label mx-1 pt-1">Periodo Activo:</label>
                <div class="col-2 mx-1">
                    <input type="date" v-model="data.periodoActual" class="form-control w-100" id="periodoActivo" readonly />
                </div>    
                <button type="button" class="btn btn-principal px-3 mx-1" alt="Inicializar nuevo periodo"
                    title="Inicializar nuevo periodo" @click="inicializar()">
                    Inicializar nuevo período
                </button> 
        </div>
</template>
   
    
<script setup lang="ts">

import { onMounted, reactive } from "vue";
import http from "@/http";
import { BreadCrumbRoute } from "@hcd-bsas/vue3-components";
import { useBreadcrumb } from "@/shared.js";
import { loading, urlApi } from "@/shared.js";
import Swal from "sweetalert2/dist/sweetalert2.js";

//entities 
import Periodo from "@/entities/Periodo";
import type { AxiosError, AxiosResponse } from "axios";

const { breadcrumb } = useBreadcrumb();

var data = reactive({
    periodoActual: null as String | null,

});

onMounted(async () => {

    loading.show();

    breadcrumb?.initRoutes([
        new BreadCrumbRoute("inicio"),
        new BreadCrumbRoute("habilitarPeriodo"),
    ]);

    await cargarPeriodoActivo();
    loading.hide();

});

function inicializar() {

    Swal.fire({
        icon: "question",
        title: "Confirmaci&oacute;n",
        html: "¿Desea habilitar el próximo período?",
        showCancelButton: true,
        confirmButtonColor: "#3085d6",
        cancelButtonColor: "#d33",
        confirmButtonText: "Confirmar",
        cancelButtonText: "Cancelar",
    }).then(async (result) => {
        if (result.isConfirmed) {
            loading.show();
            await http.post(urlApi + "inicializarPeriodo", {
                f_periodo: data.periodoActual
            }).then(async () => {

                await cargarPeriodoActivo();
                Swal.fire({
                    icon: "success",
                    text: "Inicialización OK",
                });

                loading.hide();
            }).catch(function (error: AxiosError<string, any>) {
                Swal.fire({
                    icon: "error",
                    title: "Error",
                    text: error.message,
                });
                loading.hide();
            });
        }
    });

}


async function cargarPeriodoActivo() {
    const paramsRequest: any = {};
    const response: AxiosResponse<Periodo[]> = await http.request<Periodo[]>({
        method: "GET",
        url: urlApi + "getPeriodoActivo",
        params: paramsRequest,
        transformResponse: [
            (datos: string) => {
                const periodo: Periodo = JSON.parse(datos)["res"][0];
                data.periodoActual = periodo.f_periodo;
            },
        ],
    });
}



</script>
    
    <!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>